codeforces - 337c Quiz【贪心】

来源:互联网 发布:mac 扫描局域网ip 编辑:程序博客网 时间:2024/05/18 04:12

C. Quiz
time limit per test
1 second
memory limit per test
256 megabytes
input
standard input
output
standard output

Manao is taking part in a quiz. The quiz consists of n consecutive questions. A correct answer gives one point to the player. The game also has a counter of consecutive correct answers. When the player answers a question correctly, the number on this counter increases by 1. If the player answers a question incorrectly, the counter is reset, that is, the number on it reduces to 0. If after an answer the counter reaches the number k, then it is reset, and the player's score is doubled. Note that in this case, first 1 point is added to the player's score, and then the total score is doubled. At the beginning of the game, both the player's score and the counter of consecutive correct answers are set to zero.

Manao remembers that he has answered exactly m questions correctly. But he does not remember the order in which the questions came. He's trying to figure out what his minimum score may be. Help him and compute the remainder of the corresponding number after division by 1000000009 (109 + 9).

Input

The single line contains three space-separated integers nm and k (2 ≤ k ≤ n ≤ 109; 0 ≤ m ≤ n).

Output

Print a single integer — the remainder from division of Manao's minimum possible score in the quiz by 1000000009 (109 + 9).

Examples
input
5 3 2
output
3
input
5 4 2
output
6
Note

Sample 1. Manao answered 3 questions out of 5, and his score would double for each two consecutive correct answers. If Manao had answered the first, third and fifth questions, he would have scored as much as 3 points.

Sample 2. Now Manao answered 4 questions. The minimum possible score is obtained when the only wrong answer is to the question 4.

Also note that you are asked to minimize the score and not the remainder of the score modulo 1000000009. For example, if Manao could obtain either 2000000000 or 2000000020 points, the answer is 2000000000 mod 1000000009, even though2000000020 mod 1000000009 is a smaller number.


题意:

有n到题,按顺序做,做完一道,得分+1。同时计数器显示连续作对的题数,如果题数大于k,此时的成绩扩大一倍。求作对m道题得到的最少分数。

思路:

贪心的算,从末尾每k-1个位置放一个没有做对的题,这样倍数最小。

对于前面的每k个翻一倍,可以得到这个公式:……2(2(2k + k)+k)……。整理就是:k*(2^pre + 2^(pre-1)……+2),对于后面,没有翻倍,直接加上就可以,注意前面还可能有没有翻倍的余项。

还有就是 是对1e9+9取余,不是1e9+7 。。。。。。。。。。。。。

#include <map>#include <set>#include <cstdio>#include <cstring>#include <algorithm>#include <queue>#include <iostream>#include <stack>#include <cmath>#include <string>#include <vector>#include <cstdlib>//#include <bits/stdc++.h>//#define LOACL#define space " "using namespace std;//typedef long long LL;typedef __int64 Int;typedef pair<int, int> paii;const int INF = 0x3f3f3f3f;const double ESP = 1e-5;const double PI = acos(-1.0);const long long MOD = 1000000009;const int MAXN = 100000 + 10;Int pow_mod(Int y) {    Int rec = 1;    Int base = 2LL;    while (y) {        if (y&1) rec = base%MOD*rec%MOD;        base = base%MOD*base%MOD;        y >>= 1;    }    return rec;}int main() {Int n, m, k;while (scanf("%I64d%I64d%I64d", &n, &m, &k) != EOF) {Int ans = 0, res;if (n < k*(n - m + 1)) {printf("%I64d\n", m);}else {m = n - m;Int pre = (n - k*m)/k;res = (n - m*k)%k;//须要加上一个MOD在进行取余,防止取余取到一个特小的数 44组测试数据卡这里ans = (k%MOD*(pow_mod(pre + 1) - 2)%MOD + res + m*(k - 1)%MOD + MOD)%MOD;printf("%I64d\n", ans);}}return 0;}



0 0